// +=============================================+
// |  ____  _            _     ____ _ _          |
// | | __ )| | ___   ___| | __/ ___(_) |_ _   _  |
// | |  _ \| |/ _ \ / __| |/ / |   | | __| | | | |
// | | |_) | | (_) | (__|   <| |___| | |_| |_| | |
// | |____/|_|\___/ \___|_|\_\\____|_|\__|\__, | |
// |                                      |___/  |
// +=============================================+
// | This is the "VIP" system of BlockCity.	 |
// | Do not modify this file.			 |
// +---------------------------------------------+
//
// +----------------------------------------------------+
// | This checks to see if you are a VIP member or not. |
// +----------------------------------------------------+
function isVIP(%blid)
{
	if(!BCDB.ExistUser(%blid))
	{
		warn("ID: "@%blid@" Was not found.");
		return false;
	}
	if(BCDB.data[%blid,"VIP"])
		return true;
	else
		return false;
}

// +--------------------------------------------------------+
// | This allows players to purchase VIP with their Blocks! |
// +--------------------------------------------------------+
function serverCmdBuyVIP(%client)
{
	if(!BCDB.ExistUser(%client.BL_ID))
	{
		//HUH? If we do get here, something is very wrong, as the client must be on the server to even run this command
		error("serverCmdBuyVIP() FATAL: Client not found.");
		return;
	}
	if(isVIP(%client.BL_ID))
	{
		messageClient(%client, "", "You are already VIP!");
		return;
	}

	// +-----------------------------------------------------------------------------------------------+
	// | If the client has more blocks than the cost, else Warn the users that they don't have enough. |
	// +-----------------------------------------------------------------------------------------------+
	if(BCDB.data[%client.BL_ID,"BLOCKS"] >= $PREF::BLOCKCITY::VIPPRICE)
	{
		BCDB.data[%client.BL_ID,"BLOCKS"] -= $PREF::BLOCKCITY::VIPPRICE;
		BCDB.data[%client.BL_ID,"VIP"] = true;
		messageClient(%client, "", "\c4 You have bought VIP!");
		if(!%client.isAdmin) %client.clanSuffix="<color:FCD116>[VIP]";
	}
	else
		messageClient(%client, "", "You do not have enough Blocks to buy VIP!");
}

// +--------------------------------+
// | This is an Admin-only feature. |
// | This grants a player VIP.	    |
// +--------------------------------+
function ServerCmdAddVIP(%client, %target)
{
	if(!%client.isAdmin) return;	//If the player is not an Admin, do nothing.

	if(%target $= "")
	{
		messageClient(%client, "", "Please enter all or part of a player's name (or BL_ID)");
		return;
	}
	if(!BCDB.ExistUser(%target)) //If the key exists (well it's most likley a BL_ID unless your not using BL_ID keys)
	{
		%target = findClientByName(%target);
		if(!isObject(%target))
		{
			messageClient(%client, "", "Player not found!");
			return;
		}
		%targetName = %target.netName;
		%targetID = %target.BL_ID;
	} else {
		%targetName = "BL_ID: "@%target@"";
		%targetID = %target;
	}
	if(isVIP(%targetID))
	{
		messageClient(%client, "", "Player is already VIP.");
		return;
	}

	//Logging features.
	$BCLOG[$BCLOG[total]] = %client.netName SPC "granted VIP to BL_ID" SPC %targetID SPC "on" SPC getDateTime();	
	$BCLOG[total]++;

	BCDB.data[%targetID,"VIP"] = true;

	MessageAll("", "\c3" @ %targetNAME SPC "has been granted VIP status!");
	if(!%target.isAdmin)
		%target.clanSuffix="<color:FCD116> [VIP]";
}
// +--------------------------------+
// | This is an Admin-only feature. |
// | This revokes a player's VIP.   |
// +--------------------------------+
function ServerCmdRemoveVIP(%client, %target)
{
	if(!%client.isAdmin) return;	//If the player is not an Admin, do nothing.

	if(%target $= "")
	{
		messageClient(%client, "", "Please enter all or part of a player's name (or BL_ID)");
		return;
	}
	if(!BCDB.ExistUser(%target)) //If the key exists (well it's most likley a BL_ID unless your not using BL_ID keys)
	{
		%target = findClientByName(%target);
		if(!isObject(%target))
		{
			messageClient(%client, "", "Player not found!");
			return;
		}
		%targetName = %target.netName;
		%targetID = %target.BL_ID;
	} else {
		%targetName = "BL_ID: "@%target@"";
		%targetID = %target;
	}
	if(!isVIP(%targetID))
	{
		messageClient(%client, "", "Player is not a VIP.");
		return;
	}

	//Logging features.
	$BCLOG[$BCLOG[total]] = %client.netName SPC "revoked VIP from BL_ID" SPC %targetID SPC "on" SPC getDateTime();	
	$BCLOG[total]++;

	BCDB.data[%targetID,"VIP"] = false;

	MessageAll("", "\c3" @ %targetNAME @ "'s VIP status has been revoked.");
	if(!%target.isAdmin)
		%target.clanSuffix="<color:030303> [REVOKED VIP]";
}

// +----------------------------------------------------+
// | Lets players see if another player has VIP or not. |
// +----------------------------------------------------+
function ServerCmdisVIP(%client, %target)
{
	if(%target $= "")
		%target = %client.netname;
	if(!BCDB.ExistUser(%target)) //If the key exists (well it's most likley a BL_ID unless your not using BL_ID keys)
	{
		%target = findClientByName(%target);
		if(!isObject(%target))
		{
			messageClient(%client, "", "Player not found!");
			return;
		}
		%targetName = %target.netName;
		%targetID = %target.BL_ID;
	} else {
		%targetName = "BL_ID: "@%target@"";
		%targetID = %target;
	}
	if(isVIP(%targetID))
		messageClient(%client, "", "\c2"@%targetName SPC "is a VIP.");
	else
		messageClient(%client, "", "\c0"@%targetName SPC "is not a VIP.");
}
