// +=============================================+
// |  ____  _            _     ____ _ _          |
// | | __ )| | ___   ___| | __/ ___(_) |_ _   _  |
// | |  _ \| |/ _ \ / __| |/ / |   | | __| | | | |
// | | |_) | | (_) | (__|   <| |___| | |_| |_| | |
// | |____/|_|\___/ \___|_|\_\\____|_|\__|\__, | |
// |                                      |___/  |
// +=============================================+
// | This is the Resource System		 |
// | Do not modify this file.			 |
// |  Mr.Doom's Resource Mod v2			 |
// | Just a cleaner dynamic version of KINEX's	 |
// | Modeled after Kunit's Resource mod.	 |
// +---------------------------------------------+

//Disappear & Reappear features

	//Reappear function
function regrow(%brick) //recreate the brick
{
	if(!isObject(%brick)) return;
	%brick.setcolliding(1);
	%brick.setRendering(1);
        %brick.setraycasting(1);
	%brick.MDRM_hits = 0;
}

	//Disappear funtion
function degrow(%brick) //recreate the brick
{
	if(!isObject(%brick)) return;
	%brick.setcolliding(0);
	%brick.setRendering(0);
        %brick.setraycasting(0);
	%brick.MDRM_hits = 0;
}

//--------------------

//Packaged Data


// +-------------------------+
// | Mr. Doom's Resource Mod |
// +-------------------------+
package MDRM
{
	function Diggerprojectile::oncollision(%this,%obj,%col,%fade,%pos,%normal)
	{
		if(!isobject(%col)) return;				//If you are not hitting an object, do nothing.
		if(!(%col.getClassName() $= "fxDtsBrick")) return;	//If the player is not hitting a brick, do nothing.
		%db = %col.getDatablock(); // Saves function calls.

		if(%db.isMDRMResource && %db.MDRM_Projectile $= "DiggerProjectile")
		{
			%col.MDRM_hits++;
			commandToClient(%obj.client, 'centerPrint', "\c4Hits \c6" @ %col.MDRM_hits @ "/" @ %db.MDRM_totalHits, 3);
			commandToClient(%obj.client, 'bottomPrint', "\c4["@%db.uiName@%db.MDRM_Cat@" Found]", 3);

			if(%col.MDRM_hits > %db.MDRM_totalHits)
				%col.MDRM_hits = 0;
			if(%col.MDRM_hits < %db.MDRM_totalHits)
				return;

			givePlayer(%obj.client,mFloor(%db.MDRM_BPH*%db.MDRM_TotalHits),"Mining");
			%db.sched = schedule(10,0,degrow,%col);
			if(%db.MDRM_RespawnMultiplier > 0)%resMulti=%db.MDRM_RespawnMultiplier;
			else %resMulti=1;
			%db.sched = schedule((%db.MDRM_BPH*%db.MDRM_TotalHits*$PREF::MDRM::RESPAWNMULTIPLIER*%resMulti),0,regrow,%col);
		} else
			commandToClient(%obj.client, 'centerPrint', "\c6This tool is for mining, use it on mining resource bricks.",3);
		Parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
	}
	function AxeProjectile::oncollision(%this,%obj,%col,%fade,%pos,%normal)
	{		
		if(!isobject(%col)) return;				//If you are not hitting an object, do nothing.
		if(!(%col.getClassName() $= "fxDtsBrick")) return;	//If the player is not hitting a brick, do nothing.
		%db = %col.getDatablock(); // Saves function calls.

		if(%db.isMDRMResource && %db.MDRM_Projectile $= "AxeProjectile")
		{
			%col.MDRM_hits++;
			commandToClient(%obj.client, 'centerPrint', "\c4Hits \c6" @ %col.MDRM_hits @ "/" @ %db.MDRM_totalHits, 3);
			commandToClient(%obj.client, 'bottomPrint', "\c4["@%db.uiName@%db.MDRM_Cat@" Found]", 3);

			if(%col.MDRM_hits > %db.MDRM_totalHits)
				%col.MDRM_hits = 0;
			if(%col.MDRM_hits < %db.MDRM_totalHits)
				return;

			givePlayer(%obj.client,mFloor(%db.MDRM_BPH*%db.MDRM_TotalHits),"Wood Cutting");
			%db.sched = schedule(10,0,degrow,%col);
			if(%db.MDRM_RespawnMultiplier > 0)%resMulti=%db.MDRM_RespawnMultiplier;
			else %resMulti=1;
			%db.sched = schedule((%db.MDRM_BPH*%db.MDRM_TotalHits*$PREF::MDRM::RESPAWNMULTIPLIER*%resMulti),0,regrow,%col);
		} else
			commandToClient(%obj.client, 'centerPrint', "\c6Axes cut trees, use it to chop resource trees.",3);
		Parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
	}	
};
activatePackage(MDRM);


//DiggerTool
datablock AudioProfile(DiggerHitSound)
{
   filename    = "base/data/sound/hammerHit.WAV";
   description = AudioClosest3d;
   preload = true;
};

//projectile
datablock ProjectileData(DiggerProjectile)
{
   directDamage        = 0;
   directDamageType  = $DamageType::Digger;
   radiusDamageType  = $DamageType::Digger;
   //particleEmitter     = as;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Digger Slice";

	// For Mr. Doom's version
	// At some point in the future.
   disallowSpawn = TRUE;
};


//////////
// item //
//////////
datablock ItemData(DiggerItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "base/data/shapes/Brickweapon.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Digger";
	iconName = "./icon_Hammer";
	doColorShift = true;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = DiggerImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(DiggerImage)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/Brickweapon.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = DiggerItem;
   ammo = " ";
   projectile = DiggerProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;
   stateTransitionOnTriggerUp[3]	= "StopFire";
   stateSound[3] = DiggerHitSound;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";
   stateSound[4] = DiggerHitSound;
	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";


};

function DiggerImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function DiggerImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}

//--------------------

//AxeTool
datablock AudioProfile(AxeHitSound)
{
   filename    = "base/data/sound/weaponSwitch.wav";
   description = AudioClosest3d;
   preload = true;
};

//projectile
datablock ProjectileData(AxeProjectile)
{
   directDamage        = 0;
   directDamageType  = $DamageType::Axe;
   radiusDamageType  = $DamageType::Axe;
   //particleEmitter     = as;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Axe Slice";

	// For Block City v3 (Mr. Doom's SimpleDB Version)
   disallowSpawn = TRUE;
};


//////////
// item //
//////////
datablock ItemData(AxeItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "base/data/shapes/Brickweapon.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Axe";
	iconName = "./icon_Hammer";
	doColorShift = true;
	colorShiftColor = "0.1 5 0.1 1.000";

	 // Dynamic properties defined by the scripts
	image = AxeImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(AxeImage)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/Brickweapon.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = AxeItem;
   ammo = " ";
   projectile = AxeProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = ".01 5 0.1 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;
   stateTransitionOnTriggerUp[3]	= "StopFire";
   stateSound[3] = AxeHitSound;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";
   stateSound[4] = AxeHitSound;
	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";


};

function AxeImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function AxeImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}
